<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.tm.SystemCreation']}"/>
    <ui:define name="body">

        <s:div id="creationDiv">
            <h2>#{messages['gazelle.common.menu.MenuRegisterANewSystem']}</h2>
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.systems.system.createANewSystem']}</ui:define>
                <p>#{messages['gazelle.systems.system.EditSystemLabel2']}</p>
                <div id="systemManager">
                    <h:form id="register">
                        <ui:decorate template="/layout/panels/_panel.xhtml">
                            <s:fragment>
                                <a4j:region id="institutionRegionEdit">
                                    <s:decorate id="institutiontNameDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="instkeywordOut"/>
                                        <ui:define name="label">
                                            #{messages['gazelle.users.institution.InstitutionKeyword']}
                                        </ui:define>
                                        <div style="display: grid;">
                                            <h:selectOneMenu styleClass="form-control gzl-form-control gzl-select-text"
                                                             id="instkeywordOut"
                                                             value="#{systemInSessionCreator.institutionForCreation}"
                                                             disabled="#{!s:hasRole('admin_role') and !s:hasRole('testing_session_admin_role') }">
                                                <s:selectItems
                                                        value="#{gazelleDAO.getPossibleInstitutionsInActivatedSessionForSystemCreationByAdmin()}"
                                                        var="companyFromList"
                                                        noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"
                                                        label="#{companyFromList.name}"/>
                                                <a4j:ajax event="change"
                                                          render="register:keywordDecoration, register:ownerDecoration"/>
                                            </h:selectOneMenu>
                                        </div>
                                    </s:decorate>
                                </a4j:region>
                                <a4j:region id="nameRegion">
                                    <s:decorate id="nameDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="systemname"/>
                                        <ui:define name="label">#{messages['gazelle.systems.system.SystemName']}
                                        </ui:define>
                                        <h:inputText styleClass=" form-control" id="systemname" maxlength="128"
                                                     size="30"
                                                     value="#{systemInSessionCreator.sysname}"
                                                     required="true">
                                        </h:inputText>
                                    </s:decorate>
                                </a4j:region>
                                <a4j:region id="typeRegion" rendered="#{applicationManager.isTestManagement()}">
                                    <s:decorate id="typeDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="SystemTypeListBox"/>
                                        <ui:define name="label">#{messages['gazelle.systems.system.SystemType']}
                                        </ui:define>
                                        <div style="display: grid;">
                                            <h:selectOneMenu styleClass="form-control gzl-form-control gzl-select-text"
                                                             id="SystemTypeListBox"
                                                             value="#{systemInSessionCreator.sysType}"
                                                             required="true">
                                                <s:selectItems value="#{systemInSessionCreator.getPossibleSystemTypes()}"
                                                               var="systemTypeFromList"
                                                               noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"
                                                               label="#{systemTypeFromList.systemTypeKeyword}"/>
                                                <a4j:ajax event="change"
                                                          listener="#{systemInSessionCreator.generateSystemKeyword()}"
                                                          render="keywordDecoration,register:keywordDecoration:keywordDiv, register:buttonDiv"/>
                                            </h:selectOneMenu>
                                        </div>
                                    </s:decorate>
                                </a4j:region>
                                <a4j:region id="keywordRegion"
                                            rendered="#{applicationManager.isTestManagement()}">
                                    <s:decorate id="keywordDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="systemkeywordIn"/>
                                        <ui:define name="label">#{messages['gazelle.systems.system.SystemKeyword']}
                                        </ui:define>
                                        <h:panelGrid columns="2">
                                            <s:div id="keywordDiv">
                                                <h:outputText id="systemkeywordOut"
                                                              value="#{systemInSessionCreator.getSystemInSessionKeywordBase()}"/>
                                                <h:outputText id="underscoreOutputCreate"
                                                              rendered="#{(systemInSessionCreator.syskeywordSuffix.length() &gt; 0) and (not empty systemInSessionCreator.sysType.systemTypeKeyword)}"
                                                              value="_"/>
                                            </s:div>
                                            <h:inputText styleClass=" form-control" id="systemkeywordIn"
                                                         maxlength="20"
                                                         size="30"
                                                         value="#{systemInSessionCreator.syskeywordSuffix}"
                                                         rendered="#{not empty systemInSessionCreator.sysType and not empty systemInSessionCreator.sysType.systemTypeKeyword}">
                                                <a4j:ajax event="keyup" render="keywordDiv"/>
                                            </h:inputText>
                                        </h:panelGrid>
                                    </s:decorate>
                                </a4j:region>
                                <a4j:region id="versionRegion">
                                    <s:decorate id="versionDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="version"/>
                                        <ui:define name="label">#{messages['gazelle.systems.system.SystemVersion']}
                                        </ui:define>
                                        <a4j:commandLink id="onBlurSystemVersion" render="versionDecoration"/>
                                        <h:inputText styleClass=" form-control" id="version" maxlength="64"
                                                     size="30"
                                                     value="#{systemInSessionCreator.sysversion}"/>
                                    </s:decorate>
                                </a4j:region>
                                <a4j:region id="ownerRegion"
                                            rendered="#{s:hasRole('admin_role') || s:hasRole('vendor_admin_role') ||s:hasRole('testing_session_admin_role') }">
                                    <s:decorate id="ownerDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="OwnerListAdmin"/>
                                        <ui:define name="label">#{messages['gazelle.systems.system.OwnerUser']}
                                        </ui:define>
                                        <div style="display: grid;">
                                            <h:selectOneMenu styleClass="form-control gzl-form-control gzl-select-text"
                                                             id="OwnerListAdmin"
                                                             value="#{systemInSessionCreator.sysOwnerId}"
                                                             required="true">
                                                <s:selectItems
                                                        value="#{systemInSessionCreator.listPossibleOwnerIds()}"
                                                        var="userFromList"
                                                        noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"
                                                        label="#{systemInSessionCreator.getDisplayNameFromId(userFromList)}"/>
                                            </h:selectOneMenu>
                                        </div>
                                    </s:decorate>
                                </a4j:region>
                            </s:fragment>
                            <div style="clear: both"><span class="required">*</span>
                                #{messages['gazelle.common.RequiredFields']}
                            </div>
                        </ui:decorate>

                        <!-- We reset the TF listboxes before displaying next page -->
                        <s:div id="buttonDiv">
                            <a4j:commandButton id="saveSystem" styleClass="gzl-btn-green"
                                               value="#{messages['gazelle.common.button.Save']}"
                                               action="#{systemInSessionCreator.addSystem()}"/>
                            <a4j:commandButton id="cancelAdminButton" styleClass="gzl-btn"
                                               value="#{messages['gazelle.common.button.Cancel']}" immediate="true"
                                               action="#{systemInSessionCreator.goToSystemList()}"
                                               execute="@this"/>
                        </s:div>
                    </h:form>
                </div>
            </ui:decorate>


        </s:div>
    </ui:define>
</ui:composition>
